<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

require (dirname(__FILE__) . '/include/init.php');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/professional/'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('cur', 'professional');

/**
 * +----------------------------------------------------------
 * 专业列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['professional']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['professional_add'],
            'href' => 'professional.php?rec=add' 
    ));
    
    // 获取参数
    $cat_id = $check->is_number($_REQUEST['cat_id']) ? $_REQUEST['cat_id'] : 0;
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    
    // 筛选条件
    $where = ' WHERE cat_id IN (' . $cat_id . $dou->dou_child_id('professional_category', $cat_id) . ')';
    if ($keyword) {
        $where = $where . " AND title LIKE '%$keyword%'";
        $get = '&keyword=' . $keyword;
    }
 
    // 排序
    $sort = $_OPEN['sort'] ? "sort ASC, " : '';
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT id, title, cat_id, image, sort, add_time FROM " . $dou->table('professional') . $where . " ORDER BY " . $sort . "id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $page_url = 'professional.php' . ($cat_id ? '?cat_id=' . $cat_id : '');
    $limit = $dou->pager($sql, 15, $page, $page_url, $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $cat_name = $dou->get_one("SELECT cat_name FROM " . $dou->table('professional_category') . " WHERE cat_id = '$row[cat_id]'");
        $add_time = date("Y-m-d", $row['add_time']);
        
        $professional_list[] = array (
                "id" => $row['id'],
                "cat_id" => $row['cat_id'],
                "cat_name" => $cat_name,
                "title" => $row['title'],
                "image" => $dou->dou_file($row['image']),
                "sort" => $row['sort'],
                "add_time" => $add_time 
        );
    }
    
    // 赋值给模板
    $smarty->assign('cat_id', $cat_id);
    $smarty->assign('keyword', $keyword);
    $smarty->assign('professional_category', $dou->get_category_nolevel('professional_category'));
    $smarty->assign('professional_list', $professional_list);
    
    $smarty->display('professional.htm');
} 

/**
 * +----------------------------------------------------------
 * 专业添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['professional_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['professional'],
            'href' => 'professional.php' 
    ));
    
    // 格式化自定义参数，并存到数组$professional，专业编辑页面中调用专业详情也是用数组$professional，
    if ($_DEFINED['professional']) {
        $defined = explode(',', $_DEFINED['professional']);
        foreach ($defined as $row) {
            $defined_professional .= $row . "：\n";
        }
        $professional['defined'] = trim($defined_professional);
        $professional['defined_count'] = count(explode("\n", $professional['defined'])) * 2;
    }
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('professional_category', $dou->get_category_nolevel('professional_category'));
    $smarty->assign('professional', $professional);
    
    $smarty->display('professional.htm');
} 

elseif ($rec == 'insert') {
    // 验证标题
    if (empty($_POST['title'])) $dou->dou_msg($_LANG['professional_name'] . $_LANG['is_empty']);
    
    // 文件上传盒子
    $image = $file->box('professional', $dou->auto_id('professional'), 'image', 'main');

    // 数据格式化
    $add_time = time();
    $_POST['defined'] = str_replace("\r\n", ',', $_POST['defined']);
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "INSERT INTO " . $dou->table('professional') . " (id, cat_id, title, defined, content, image ,keywords, description, sort, add_time)" . " VALUES (NULL, '$_POST[cat_id]', '$_POST[title]', '$_POST[defined]', '$_POST[content]', '$image', '$_POST[keywords]', '$_POST[description]', '$_POST[sort]', '$add_time')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['professional_add'] . ': ' . $_POST['title']);
    $dou->dou_msg($_LANG['professional_add_succes'], 'professional.php');
} 

/**
 * +----------------------------------------------------------
 * 专业编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['professional_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['professional'],
            'href' => 'professional.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $professional = $dou->get_row('professional', '*', "id = '$id'");
    
    // 格式化数据
    $professional['image'] = $dou->dou_file($professional['image']);
    
    // 格式化自定义参数
    if ($_DEFINED['professional'] || $professional['defined']) {
        $defined = explode(',', $_DEFINED['professional']);
        foreach ($defined as $row) {
            $defined_professional .= $row . "：\n";
        }
        // 如果专业中已经写入自定义参数则调用已有的
        $professional['defined'] = $professional['defined'] ? str_replace(",", "\n", $professional['defined']) : trim($defined_professional);
        $professional['defined_count'] = count(explode("\n", $professional['defined'])) * 2;
    }
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('professional_category', $dou->get_category_nolevel('professional_category'));
    $smarty->assign('professional', $professional);
    
    $smarty->display('professional.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // 验证标题
    if (empty($_POST['title'])) $dou->dou_msg($_LANG['professional_name'] . $_LANG['is_empty']);
        
    // 文件上传盒子
    $image = $file->box('professional', $id, 'image', 'main');
    $image = $image ? ", image = '" . $image . "'" : '';
    
    // 格式化自定义参数
    $_POST['defined'] = str_replace("\r\n", ',', $_POST['defined']);
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "UPDATE " . $dou->table('professional') . " SET cat_id = '$_POST[cat_id]', title = '$_POST[title]', defined = '$_POST[defined]' ,content = '$_POST[content]'" . $image . ", keywords = '$_POST[keywords]', description = '$_POST[description]', sort = '$_POST[sort]' WHERE id = '$id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['professional_edit'] . ': ' . $_POST['title']);
    $dou->dou_msg($_LANG['professional_edit_succes'], 'professional.php');
}

/**
 * +----------------------------------------------------------
 * 专业删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'professional.php');
    $title = $dou->get_one("SELECT title FROM " . $dou->table('professional') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm'])) {
        // 删除相应商品图片
        $image = $dou->get_one("SELECT image FROM " . $dou->table('professional') . " WHERE id = '$id'");
        $dou->del_file($image);
        
        $dou->create_admin_log($_LANG['professional_del'] . ': ' . $title);
        $dou->delete('professional', "id = $id", 'professional.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $title, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'professional.php', '', '30', "professional.php?rec=del&id=$id");
    }
} 

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') {
            // 批量专业删除
            $dou->del_all('professional', $_POST['checkbox'], 'id', 'image');
        } elseif ($_POST['action'] == 'category_move') {
            // 批量移动分类
            $dou->category_move('professional', $_POST['checkbox'], $_POST['new_cat_id']);
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['professional_select_empty']);
    }
}

?>